**************************************************************
* a program by Russ Halbert (K0LUW) to analyize a adi log file
* and compare it to the tribunelist to see who has not been worked
* written for the SKCC
**************************************************************
set safety off
close database
set development on
close database

on error do errrtn with lineno(), program()

if 'VISUAL' $ upper(version())    && check the version
   isvfp = .t.
else
   isvfp = .f.
endif

PUBLIC _mypath, myresource, tmpdir, dbfdir, datadir, altdir, outdir
public awarddir, skccdata
public verts, bailout, dbfname, win_name, filt_expr, srchterm, qsl

_mypath = alltrim(sys(5))+alltrim(curdir())
tmpdir=_mypath+'temp\'
set default to (tmpdir)

m.verts = 'Version 1a 11/1/2014'
m.myresource = sys(2005)
m.runcmd=''
m.srec = 0
m.tx8_date = ctod(' ')

* location parms
rootdir = _mypath
tmpdir=rootdir+'temp\'
skccdir=tmpdir
indir = rootdir+ 'work\'
workdir = indir
dbfdir = rootdir+'data\'
datadir = rootdir+'data\'
srcdir = rootdir+'src\'
outdir=indir
CTLSYSAPP = rootdir+'src\'
softerr = 0
t_prog = program()

* reserved number and prior calls
*   if skcc = 1169 or skcc = 5578 or skcc = 7451 or skcc = 9456  (around line 206)
*  1169 was wb9tpa
*  5578 was w3vr
*  7451 was ku5q
*  9456 was ah6v in HI

m.loadspc = .t.

*list memory to c:\memory.txt

cnt_skccdata = 0
cnt_triblist = 0

*-------parms------------
modify window screen from 0,0 to 30,92 noclose
set sysmenu to


select 0
use (tmpdir+'inadi') excl alias adi
do zapper
use

m.incall = '        '
txtinfile = 'C:\senators\work\mylog.adi'
m.bandpick = 1

* --------------- start the screen ------------------------
select 0
use (dbfdir+'mydata')
goto top
m.incall = mydata.call
m.txtinfile = upper(alltrim(mydata.logfile))
m.bandpick = mydata.bandpick
use

m.exitloop = 0
m.okcancel = 0

do while m.exitloop = 0
   m.exitloop = 1
   do form chkform.scx
   if m.okcancel = 1
   else
      quit
   endif
*    --------- check the screen data -----------------------

   m.incall=upper(alltrim(m.incall))   && screen txtincall2
   inlog=m.txtinfile

   select 0
   use (dbfdir+'mydata')
   goto top
   replace call with m.incall
   replace logfile with upper(alltrim(m.txtinfile))
   replace bandpick with m.bandpick

   select 0
   use (dbfdir+'allskcc')
   set order to call
   if seek(m.incall,'allskcc')
      scatter memvar
      replace mydata.skcc_date with m.skcc_date
      replace mydata.tx8_date with m.tx8_date
      replace mydata.trib_date with m.trib_date
      select mydata
      use
      select allskcc

      = fileproc(txtinfile)

      do datadown
      do procdata

      do csvout with 'needs'
      do csvout with 'worked'
      use
   else
      m.exitloop = 0
      use

      wait "Member not found" window timeout 5
   endif
enddo

wait "All Done -  check the Work directory for results" window timeout 5
quit

**
procedure lister
**
set console off
list memory to c:\memory.txt
set console on
return

**
procedure procdata
**

wait 'Processing the data' window nowait

select 0
use (dbfdir+'allskcc')
set order to call
if seek(m.incall,'allskcc')
   scatter memvar
else
   scatter memvar blank
endif

if m.tx8_date > ctod(' ')
   if m.tx8_date < ctod('08/01/2013')
      m.tx8_date = ctod('08/01/2013')
   endif
endif

if m.tx8_date = ctod(' ')
   Wait "The Callsign does not have a Tx8 - cannot process" window timeout 5
   quit
endif

select 0
use (tmpdir+'inadi') excl
goto top
do while .not. eof()
   if seek(call,'allskcc')
      replace skcc with allskcc.skcc
      replace cent_date with allskcc.cent_date
      replace trib_date with allskcc.trib_date
      replace sen_date with allskcc.sen_date
   else
      replace skcc with 0
   endif
   do case
      case val(band) > 0
         replace band with alltrim(str(val(band)))+'M'
      case  val(band) = 0 and freq > 0
         replace band with alltrim(gtband(freq))+'M'
      case  val(band) = 0 and freq = 0
         delete
   endcase
   if mode = 'CW'
   else
      delete
   endif
   if qso_date = ctod(' ') or trib_date = ctod(' ') or  qso_date < trib_date
      delete
   endif
   if skcc = 0 or qso_date < m.tx8_date or  qso_date < ctod('08/01/2013')
      delete
   endif
   skip
enddo
pack
goto top

do while .not. eof()
   do case
      case m.bandpick = 1
      case m.bandpick = 2
         if band = '10M'
         else
            delete
         endif
      case m.bandpick = 3
         if band = '12M'
         else
            delete
         endif
      case m.bandpick = 4
         if band = '15M'
         else
            delete
         endif
      case m.bandpick = 5
         if band = '17M'
         else
            delete
         endif
      case m.bandpick = 6
         if band = '20M'
         else
            delete
         endif
      case m.bandpick = 7
         if band = '30M'
         else
            delete
         endif
      case m.bandpick = 8
         if band = '40M'
         else
            delete
         endif
      case m.bandpick = 9
         if band = '60M'
         else
            delete
         endif
      case m.bandpick = 10
         if band = '160M'
         else
            delete
         endif
      case m.bandpick = 11
         if band = '6M'
         else
            delete
         endif
   endcase
   skip
enddo

pack
use


select 0
use (tmpdir+'inadi') excl
goto top

index on skcc to (tmpdir+'ie') unique
copy to (tmpdir+'x') fox2x
goto top
do zapper
use


select 0
use (tmpdir+'inadi') excl
goto top
do zapper
use


select 0
use (tmpdir+'inadi') excl
append from (tmpdir+'x')
index on skcc tag skcc
close database

select 0
use (tmpdir+'inadi')
set order to skcc

select 0
use (dbfdir+'tribs')
copy fields call, skcc, name, city, spc to (tmpdir+'needs') fox2x
use

select 0
use (tmpdir+'needs') excl
goto top
do while .not. eof()
   if seek(skcc,'inadi')
      delete
   endif
   skip
enddo
pack
index on call tag call
copy to (tmpdir+'x') fox2x
do zapper
append from (tmpdir+'x')

close database

select 0
use (tmpdir+'inadi') excl
index on dtoc(qso_date,1) tag qso_ordr
copy fields qso, qso_date, call, skcc, name, state, band to (tmpdir+ 'worked') fox2x
use

select 0
use (tmpdir+'worked') excl
replace all qso with recno()
use

close database
return

**
procedure datadown
**

** if VFP Running - get the web files **
if isvfp = .t.
   select 0
   use (datadir+'infiles') alias a
   goto top

   do while .not. eof()
      wait "Downloading "+alltrim(a.fileid)+' to '+alltrim(a.tmpid) window nowait
      lcUrl = alltrim(a.inputurl)
      target = alltrim(a.target)
      lcLocalFile = tmpdir+alltrim(a.target)+".txt"
      outFile = datadir+alltrim(a.tmpid)+".txt"

      If getFileFromURL(m.lcUrl,m.lcLocalFile)
         =filfix(m.lcLocalFile,m.outfile)
      Endif

      select 0
      use (dbfdir+alltrim(a.outdb)) excl alias b
      delete all
      pack

      flush
      append from (dbfdir+alltrim(a.tmpid)+'.txt') delimited with tab
      goto top
      delete
      pack
      cntv = 'm.'+alltrim(a.cntname)
*      wait 'table ->'+cntv+'<- '+ str(reccount(),7) window timeout 10
      &cntv = reccount()
      replace a.last_cnt with a.db_cnt
      replace a.db_cnt with reccount()

      goto top
      m.outdb = upper(alltrim(a.outdb))
      m.localproc = upper(alltrim(a.localproc))
      do case
         case m.localproc = 'TRIBLOAD'
            DO TRIBLOAD
         case m.localproc = 'DATALOAD'
            do dataload
         otherwise
            do while .not. eof()
               do case
                  case Upper(alltrim(a.outdb)) $ 'SKCC,SKCCDTA,MPLYLIST,MPLRLIST,MPLOLIST,MPLGLIST'
                     replace b.skcc with val(b.skccin)
                     if Upper(alltrim(a.outdb)) $ 'MPLYLIST,MPLRLIST,MPLOLIST,MPLGLIST'
                        replace b.ddate with dtchange(upper(b.tdate))
                     endif
                  case Upper(alltrim(a.outdb)) $ 'DXLIST'
                     replace b.skcc with val(b.skccin)
                     replace b.ddate with dtchange(upper(b.tdate))
                     replace b.edate with dtchange(upper(b.cdate))
                  otherwise
                     replace b.skcc with val(b.skccin)

                     replace b.ddate with dtchange(b.tdate)
                     rs = upper(b.num)
                     bx = 1
                     j=at('X',rs)
                     if j > 0
                        bx = val(substr(rs,j+1))
                     endif
                     replace b.numx with bx
                     if Upper(alltrim(a.outdb)) = 'CENTURN'
                        replace b.centdate with b.ddate
                     else
                        m.endors = b.endors
                     endif
               endcase
               skip
            enddo
      endcase
      index on skcc tag skcc
      use
      select a
      skip
   enddo

   use
else
   quit
endif


select 0
use (dbfdir+'skccdata') excl
delete all
pack
append from (dbfdir+'skccdta')
reindex
use

do makeallskcc
close database
return

**
procedure csvout
**
parameter infile
private outdt, outval, indtc

select 0
use (tmpdir+infile)  alias fl
goto top

n=afields(flist)
set console off
set alternate to (indir+infile+'.csv')
set alternate on
outl=''
for i = 1 to n
   if i = n
      outl = outl+lower(alltrim(flist[i,1]))
   else
      outl = outl+lower(alltrim(flist[i,1]))+','
   endif
next i
??outl

do while .not. eof()
   outln = ''
   outl=''
   outfld = ''
   outval = ''
   for i = 1 to n
      outfld = 'fl.'+alltrim(flist[i,1])
      do case
         case alltrim(flist[i,2]) = 'C'
             outval = &outfld
             outval = '"'+alltrim(outval)+'"'
         case alltrim(flist[i,2]) = 'N'
             outval = alltrim(str(&outfld))
         case alltrim(flist[i,2]) = 'D'
             outdt = &outfld
             indtc = dtoc(outdt,1)
             outval = '"'+substr(indtc,1,4)+'-'+substr(indtc,5,2)+'-'+substr(indtc,7,2)+'"'
      endcase

      if i = n
         outl = outl+outval
      else
         outl = outl+outval+','
      endif
   next i
   ?outl
   skip
enddo
*?? chr(13)+chr(10)
close alternate

close database

set console off
h=fopen(indir+infile+'.csv',2)
 =fchsize(h,fseek(h,-1,2))
 =fclose(h)
set console on

return




***
procedure fileproc
**
parameter z1

wait "Reading: "+z1 window nowait

if file(z1)
else
   wait 'no input file found' window timeout 5
   quit
endif

  _out = ''
  _fh = fopen(z1,0)

  do while .not. feof(_fh) .and. _fh > 0
     _ch = fread(_fh,1)
     do case
*        case _ch = ' '
        case asc(_ch) < 32
        otherwise
            _out = _out + _ch
     endcase
     if '<EOH>' $ upper(_out)
         exit
     endif
  enddo

select 0
use (tmpdir+'inadi') excl alias adi
scatter memvar blank

do while .not. feof(_fh) .and. _fh > 0
  _out = ''
  do while .not. feof(_fh) .and. _fh > 0 and !'<EOR>' $ upper(_out)
     _ch = fread(_fh,1)
     do case
*        case _ch = ' '
        case asc(_ch) < 32
        otherwise
            _out = _out + _ch
     endcase
  enddo
  m.call = ''
  && end of a record found
  if len(alltrim(_out)) > 0
     qd = gtfld(_out,'QSO_DATE:')
     do case
        case len(qd) = 6
           qd = '20'+qd
        case len(qd) = 8
     endcase

     m.qso_date = ctod(substr(qd,5,2)+'/'+ substr(qd,7,2)+'/'+substr(qd, 1,4))
     m.stn = 'K3Y/9'
     M.CALL = gtfld(_out,'CALL:')
     M.NAME = gtfld(_out,'NAME:')
     M.TIME_ON = gtfld(_out,'TIME_ON:')
     M.FREQ = VAL(gtfld(_out,'FREQ:'))
     if m.freq > 1000
        m.freq = m.freq / 1000
     endif
     M.BAND = upper(gtfld(_out,'BAND:'))
     M.MODE = gtfld(_out,'MODE:')
     M.QTH = gtfld(_out,'QTH:')
     M.STATE = gtfld(_out,'STATE:')
     M.rst_sent = gtfld(_out,'RST_SENT:')
     M.rst_RCVD = gtfld(_out,'RST_RCVD:')
     M.STATE = gtfld(_out,'STATE:')
     M.comment = gtfld(_out,'COMMENT:')
     if m.call = ' '
     else
        select adi
        append blank
        gather memvar
        scatter memvar blank
     endif
  endif

enddo

close database
wait "Done Reading: "+z1 window nowait

return


**
Function gtfld
**
parameter _inl, _inf
private _inl, _inf, _insrch, _outf, _j, _k, _l, _outval
   _outval = ''
   _insrch = '<'+_inf
   _j = at(upper(_insrch),upper(_inl))

  if _j > 0
     _inl = substr(_inl,_j)     && <QSO_date:8> asdfadfadf
     _j = at(':',_inl)
     if _j > 0
        _inl = substr(_inl,_j+1)  && 8> asdadsaf
        _j = at('>',_inl)
        if _j > 0
           _l = val(substr(_inl,1,_j-1))
           _inl = substr(_inl,_j+1)
           if _l > 0
              _outval = substr(_inl,1,_l)
           endif
        endif
     endif
  endif
return _outval


**
procedure populate
**

wait "Processing input data" window nowait
select 0
use (dbfdir+'tribs')
copy to (tmpdir+'needs') with cdx fox2x
use

select 0
use (dbfdir+'allskcc') excl
set order to call

select 0
use (tmpdir+'inadi') excl alias adi
replace all ts with dtoc(qso_date,1)+' '+time_on
*delete all for call = '  '
pack
goto top

do while .not. eof()
   if seek(call,'skcc')
      replace skcc with skcc.skcc
      replace skcc_cent with skcc.skcc_cent
      replace skcc_trib with skcc.skcc_trib
      replace skcc_date with skcc.skcc_date
      replace cent_date with skcc.cent_date
      replace trib_date with skcc.trib_date
      do case
         case skcc.cent_date = ctod(' ')
              replace skccin with skcc.skccin
         case qso_date < skcc.cent_date
              replace skccin with alltrim(str(val(skcc.skccin),6))
         case qso_date < skcc.trib_date
              replace skccin with alltrim(str(val(skcc.skccin),6))+'C'
         case qso_date >= skcc.trib_date
              replace skccin with alltrim(str(val(skcc.skccin),6))+'T'
         otherwise
              replace skccin with skcc.skccin
      endcase
      replace chg_call with skcc.oldcall

   else

      if seek(call,'old')
         replace chg_call with call
         replace call with old.call
         replace skcc with old.skcc
         replace skcc_cent with old.skcc_cent
         replace skcc_trib with old.skcc_trib
         replace skcc_date with old.skcc_date
         replace cent_date with old.cent_date
         replace trib_date with old.trib_date

         *replace skccin with old.skccin
         replace skccin with '**'
      else
         replace comment with '#04# '+ alltrim(comment)

      endif
   endif
   skip
enddo




goto top
do while .not. eof()
   if m.inskcdate = ctod(' ')
   else
      if qso_date < m.inskcdate
         replace comment with '#00# '+ alltrim(comment)
         skip
         loop
      endif
   endif
   if qso_date < ctod('03/01/2007')
      replace comment with '#01# '+ alltrim(comment)
      skip
      loop
   endif
   if qso_date < incent_date
      replace comment with '#02# '+ alltrim(comment)
      skip
      loop
   endif


   if cwfilter = .t.
      if mode = 'CW'
      else
         delete
         skip
         loop
      endif
   endif

   if cwcheck = .t.
      if mode = 'CW'
      else
         replace comment with '#03# '+ alltrim(comment)
         skip
         loop
      endif
   endif

   do case
      case qso_date >= cent_date and cent_date <> ctod(' ')
         replace qso with 1
      otherwise
         if qso_date < ctod('01/01/2009')
            do case
               case call = 'K9SKC'
                  replace skcc with 99989
                  replace qso with 1
                  replace skccin with alltrim(str(skcc))+'T'
                  replace cent_date with ctod('01/01/2007')
                  replace trib_date with ctod('01/01/2007')

               case call = 'K2A/1'
                  replace skcc with 99991
                  replace qso with 1
                  replace skccin with alltrim(str(skcc))+'T'
                  replace cent_date with ctod('01/01/2007')
                  replace trib_date with ctod('01/01/2007')

               case call = 'K2A/2'
                  replace skcc with 99992
                  replace qso with 1
                  replace skccin with alltrim(str(skcc))+'T'
                  replace cent_date with ctod('01/01/2007')
                  replace trib_date with ctod('01/01/2007')

               case call = 'K2A/3'
                  replace skcc with 99993
                  replace qso with 1
                  replace skccin with alltrim(str(skcc))+'T'
                  replace cent_date with ctod('01/01/2007')
                  replace trib_date with ctod('01/01/2007')

               case call = 'K2A/4'
                  replace skcc with 99994
                  replace qso with 1
                  replace skccin with alltrim(str(skcc))+'T'
                  replace cent_date with ctod('01/01/2007')
                  replace trib_date with ctod('01/01/2007')

               case call = 'K2A/5'
                  replace skcc with 99995
                  replace qso with 1
                  replace skccin with alltrim(str(skcc))+'T'
                  replace cent_date with ctod('01/01/2007')
                  replace trib_date with ctod('01/01/2007')

               case call = 'K2A/6'
                  replace skcc with 99996
                  replace qso with 1
                  replace skccin with alltrim(str(skcc))+'T'
                  replace cent_date with ctod('01/01/2007')
                  replace trib_date with ctod('01/01/2007')

               case call = 'K2A/7'
                  replace skcc with 99997
                  replace qso with 1
                  replace skccin with alltrim(str(skcc))+'T'
                  replace cent_date with ctod('01/01/2007')
                  replace trib_date with ctod('01/01/2007')

               case call = 'K2A/8'
                  replace skcc with 99998
                  replace qso with 1
                  replace skccin with alltrim(str(skcc))+'T'
                  replace cent_date with ctod('01/01/2007')
                  replace trib_date with ctod('01/01/2007')

               case call = 'K2A/9'
                  replace skcc with 99999
                  replace qso with 1
                  replace skccin with alltrim(str(skcc))+'T'
                  replace cent_date with ctod('01/01/2007')
                  replace trib_date with ctod('01/01/2007')

               case call = 'K2A/0'
                  replace skcc with 99990
                  replace qso with 1
                  replace skccin with alltrim(str(skcc))+'T'
                  replace cent_date with ctod('01/01/2007')
                  replace trib_date with ctod('01/01/2007')

               otherwise
                  replace skccin with alltrim(str(skcc))
            endcase
       endif
   endcase
   skip
enddo
index on ts to (tmpdir+'ie')
copy to (tmpdir+'save') fox2x
copy to (tmpdir+'x') fox2x
do zapper
append from (tmpdir+'x')


close database
return


**
procedure makeallskcc  && create the allskcc.dbf
**

select 0
use (dbfdir+'skccdata') excl alias sk
copy to (dbfdir+'allskcc') with cdx fox2x

select 0
use (dbfdir+'allskcc') excl alias ak

select sk
goto 2
do while .not. eof()
   if sk.oldcall = '   '
   else
       m.ocall = alltrim(sk.oldcall)
       do while len(alltrim(m.ocall)) > 0
          j=at(',',m.ocall)
          if j > 0
             m.ncall = substr(m.ocall,1,j-1)
             m.ocall = alltrim(substr(m.ocall,j+1))
          else
             m.ncall = alltrim(m.ocall)
             m.ocall = ''
          endif
          scatter memvar
          m.call = m.ncall
          select ak
          append blank
          gather memvar
          select sk
      enddo
   endif
   select sk
   skip
enddo
close database

return


**
procedure zapper
**
delete all
pack
return


**
Procedure getFileFromURL
**
Lparameters tcRemoteFile,tcLocalFile
Declare Integer URLDownloadToFile In urlmon.Dll;
INTEGER pCaller, String szURL, String szFileName,;
INTEGER dwReserved, Integer lpfnCB
DECLARE INTEGER DeleteUrlCacheEntry IN wininet;
    STRING lpszUrlName

*?'Delete Cache Code: '
*??DeleteUrlCacheEntry(m.tcRemotefile)
Return URLDownloadToFile(0, m.tcRemoteFile, m.tcLocalFile, 0, 0) = 0
Endproc



**
function milldate
**
parameter foxdate
private foxdate, td, j, dd, mm, yy, ttdate, monstr
monstr='JANFEBMARAPRMAYJUNJULAUGSEPOCTNOVDEC'

    if foxdate = ctod(' ')
       return ''
    endif
    td = dtoc(foxdate,1)        && to 20050301 format

    dd = substr(td,7,2)

    j = (val(substr(td,5,2)) * 3) - 2
    mm = proper(substr(monstr,j,3))

    yy = substr(td,1,4)

    m.ttdate = dd+' '+ mm+' '+ yy

return m.ttdate



**
procedure dataload
**
*-------------skccdata--------------------------


replace all skcc with val(skccin)
replace all skcc_date with dtchange(skccdate)
replace all cent_date with dtchange(centdate)
replace all trib_date with dtchange(tribdate)
replace all tx8_date with dtchange(tx8date)
replace all sen_date with dtchange(sendate)


return


**
procedure tribload
**
*-------------tribs--------------------------


replace all skcc with val(skccin)
replace all ddate with dtchange(tdate)
goto top
do while .not. eof()
   rs = upper(num)
   bx = 1
   j=at('X',rs)
   if j > 0
      bx = val(substr(rs,j+1))
   endif
   replace numx with bx
   m.endors = b.endors
*
* two comma problem - replace 1 comma with space
*
   j= at(',,', m.endors)
   if j > 0
      m.endors = substr(m.endors, 1, j) + ' ' + substr(m.endors,j+2)
   endif

   tx8dt=''
   j = at('*', m.endors)
   if j > 0
      tx8dt = alltrim(substr(m.endors,j+6,11))
      replace b.tx8_date with dtchange(tx8dt)
      m.endors = substr(m.endors,1,j-1)
   endif

   if len(alltrim(m.endors)) > 0

      rs = upper(alltrim(m.endors))
      do while len(rs) > 0
         aa=commer(@rs)
         j=at('M',aa)
         if j > 0
            bx = 1
            bd = 'b.M'+substr(aa,1,j-1)
            j=at('X',aa)
            if j = 0
            else
               bx = val(substr(aa,j+1))
            endif
            replace &bd with bx
         endif
      enddo
   endif
   skip
enddo

index on skccin tag skccin
index on skcc tag skcc
return
**
function chunker
**
parameter _lin
private _lin, _j, _out
     _out = ''
     IF LEN(_lin) > 1
        j = at('|',_lin)
        IF j > 0
           _out = substr(_lin, 1, j - 1)
           if len(_lin) > j
              _lin = substr(_lin, j + 1)
           else
              _lin = ''
           endif
        else
           _out = _lin
           _lin = ''
        ENDIF
     ENDIF
return _out



**
procedure filfix
**
parameter z1, z6
private z1, z6

*  OPEN z1$ FOR BINARY AS #1
*  OPEN z6$ FOR OUTPUT AS #6
wait "Converting "+z1 window nowait
if file(z6)
   delete file (z6)
endif

if file(z1)
  _fw = fcreate(z6,0)

  _fh = fopen(z1,0)
  do while .not. feof(_fh) .and. _fh > 0
     _ch = fread(_fh,1)
     do case
        case asc(_ch) = 10
           _out = chr(13)+_ch
        case _ch = '|'
           _out = chr(9)
        otherwise
           _out = _ch
     endcase
     =fwrite(_fw,_out)
  enddo
  =fclose(_fh)
  =fclose(_fw)
endif
if file(z1)
*   delete file (z1)
endif

RETURN


**
procedure yfilfix
**
parameter z1, z6
private z1, z6

*  OPEN z1$ FOR BINARY AS #1
*  OPEN z6$ FOR OUTPUT AS #6
?"Converting"
if file(z6)
   delete file (z6)
endif

if file(z1)
  _fw = fcreate(z6,0)

  _fh = fopen(z1,0)
  do while .not. feof(_fh) .and. _fh > 0
     _ch = fread(_fh,1)
     if asc(_ch) = 10
        _out = chr(13)+_ch
     else
        _out = _ch
     endif
     =fwrite(_fw,_out)
  enddo
  =fclose(_fh)
  =fclose(_fw)
endif
if file(z1)
*   delete file (z1)
endif

RETURN




**
procedure xfilfix
**


*  OPEN z1$ FOR BINARY AS #1
*  OPEN z6$ FOR OUTPUT AS #6

if file(z6)
   delete file (z6)
endif

if file(z1)
  _fw = fcreate(z6,0)
  ?'fw ->', _fw

  _fh = fopen(z1,0)
  do while .not. feof(_fh) .and. _fh > 0
     _ch = fread(_fh,1)
     if asc(_ch) = 10
        _out = chr(13)+_ch
     else
        _out = _ch
     endif
     =fwrite(_fw,_out)
  enddo
  =fclose(_fh)
  =fclose(_fw)
endif
RETURN

**
function desuffix
**
parameter _txt
private i, _txt
_otxt = ''
_txt = alltrim(_txt)

for i=1 to len(_txt)
   _ch = substr(_txt,i,1)
   do case
      case asc(_ch) = 146
           _otxt = _otxt + _ch
      case asc(_ch) < 32 .or. asc(_ch) > 122
      otherwise
           _otxt = _otxt +_ch
   endcase
next i
return _otxt

**
function desuffix2
**
parameter _txt
private i, _txt
_otxt = ''
_txt = alltrim(_txt)

for i=1 to len(_txt)
   _ch = substr(_txt,i,1)
   do case
      case asc(_ch) < 32 .or. asc(_ch) > 122
      otherwise
           _otxt = _otxt +_ch
   endcase
next i
return _otxt


**
function dehypen
**
parameter _txt
private i, _txt, _otxt
_otxt = ''
for i=1 to len(_txt)
   if substr(_txt,i,1) = '-'
   else
      _otxt = _otxt + substr(_txt,i,1)
   endif
next i
return _otxt



**
function dtchange
**
parameter textdate
private textdate, td, j, dd, mm, yy, tttdate, monstr
monstr='JANFEBMARAPRMAYJUNJULAUGSEPOCTNOVDEC'

    td=upper(alltrim(textdate))
    j=at(' ',td)
    dd = fldedit(substr(td,1,j-1),2)
    td=alltrim(substr(td,j+1))
    mm = substr(td,1,3)
    j=at(' ',td)
    td=alltrim(substr(td,j+1))
    yy = fldedit(td,4)
    j=(at(mm,monstr)+2) / 3
    mm = fldedit(j,2)
    m.tttdate = mm+'/'+dd+'/'+yy

return ctod(m.tttdate)



**
function dtchange2
**
parameter textdate
private textdate, td, j, ddate, mdate, ydate, ttdate, monstr
monstr='JANFEBMARAPRMAYJUNJULAUGSEPOCTNOVDEC'

    td=upper(alltrim(textdate))
    mdate = substr(td,1,3)
    j=(at(mdate,monstr)+2) / 3
    mdate = fldedit(j,2)
    td = substr(td,5)

    j=at(',',td)
    ddate = fldedit(substr(td,1,j-1),2)
    td=alltrim(substr(td,j+2))

    ydate = fldedit(td,4)
    m.ttdate = mdate+'/'+ddate+'/'+ydate

return ctod(m.ttdate)


* function to pad with 0's
**
function fldedit
**
parameter innum, outlen
private outnum
  do case
     case type('innum')='C'
        outnum = right(replicate('0',outlen)+alltrim(str(val(innum))),outlen)
     case type('innum')='N'
        outnum = right(replicate('0',outlen)+alltrim(str(innum)),outlen)
     otherwise
        outnum = '0'
  endcase
return outnum


**
function commer
**
parameter _lin
private _lin, _j, _out
     _out = ''
     IF LEN(_lin) > 1
        j = at(',',_lin)
        IF j > 0
           _out = alltrim(substr(_lin, 1, j - 1))
           if len(_lin) > j
              _lin = alltrim(substr(_lin, j + 1))
           else
              _lin = ''
           endif
        else
           _out = _lin
           _lin = ''
        ENDIF
     ENDIF
return _out





**
function myfile
**
parameter _dfile, _p3, _p4, _p5
private dirarray
dimension dirarray(5)

   if adir(dirarray, (_dfile)) != 0

      _xfile = .t.

      _p3=str(dirarray(2))                            && file size
***                                                   && file data/time
      _p4= dtoc(dirarray(3),1)+' '+dirarray(4)

      =adir(dirarray, (_dfile),'V')

      _p5= dirarray(1)                                && volume

   else
      ?'File not found'
      _xfile = .f.
   endif

return _xfile

**
function newerfile
**
parameter _nfile, _ofile
private _f3, _f4, _f5, _o4, _o3, o5, _mexit
* is _nfile newer than _ofile
* return .t. if it is

_mexit = .t.

_f3 = ' '
_f4 = ' '
_f5 = 'AA'
if type('_nfile') <> 'C'
    ?'bad input file name'
   _mexit = .f.
else
   if len(alltrim(_nfile)) = 0
       ?'no file name given'
      _mexit = .f.
   else
      if myfile(_nfile, @_f3, @_f4, @_f5)
*_f4 is timestamp

         if val(_f3) = 0
           ?'flunked file size'
            _mexit = .f.
         endif
      else
         _mexit = .f.
      endif
   endif
endif


_o3 = ' '
_o4 = ' '
_o5 = 'AA'
if type('_ofile') <> 'C'
    ?'bad input file name'
   _mexit = .f.
else
   if len(alltrim(_ofile)) = 0
       ?'no file name given'
      _mexit = .f.
   else
      if myfile(_ofile, @_o3, @_o4, @_o5)
*_o4 is timestamp
         if val(_o3) = 0
           ?'flunked file size'
            _mexit = .f.
         endif
      else
         _mexit = .f.
      endif
   endif
endif

?_f4
?_o4

if _mexit = .t.
   if _f4 >= _o4
      _mexit = .t.
   else
      _mexit = .f.
   endif
endif

return _mexit


**
function chkdate
**
parameter indt
private indt, dtok

* date format should be dd Mth yyyy ie. '01 Jan 2013'
m.dtok = 0.
m.indt = alltrim(m.indt)

do case
   case len(m.indt) > 11 or len(m.indt) < 11
     m.dtok = 12
   case ! substr(m.indt,1,1) $ '0123456789'
     m.dtok = 1
   case ! substr(m.indt,2,1) $ '0123456789'
     m.dtok = 2
   case ! substr(m.indt,3,1) $ ' '
     m.dtok = 3
   case ! substr(m.indt,4,3) $ 'JanFebMarAprMayJunJulAugSepOctNovDec'
     m.dtok = 4
   case ! substr(m.indt,7,1) $ ' '
     m.dtok = 7
   case ! substr(m.indt,8,1) $ '2'
     m.dtok = 8
   case ! substr(m.indt,9,1) $ '01'
     m.dtok = 9
   case ! substr(m.indt,10,1) $ '0123456789'
     m.dtok = 10
   case ! substr(m.indt,11,1) $ '0123456789'
     m.dtok = 11
endcase
return m.dtok


**
FUNCTION ARCHFILE
**
parameter zipname, infile
   RUNCMD = CTLSYSAPP+'PKZIP -A -) '+ zipname + ' ' + infile
*   =ADDLOG("Adding to ARCHIVE :" + RUNCMD ,t_prog)
   RUN &RUNCMD
return .t.

**
FUNCTION ARCHDIR
**
parameter zipname, infile
   RUNCMD = CTLSYSAPP+'PKZIP -A -) '+ zipname + ' ' + infile
*   =ADDLOG("Adding to ARCHIVE :" + RUNCMD ,t_prog)
   RUN &RUNCMD
return .t.

**
FUNCTION GETAJOB
**
* return the xadecimal (base 36) datetime string as a jobnum
*
private wrkarea, sctl, _jobnum
dimension _alph[36]
for _i=48 to 57
   _alph[_i-47]=chr(_i)
endfor
for _i=65 to 90
   _alph[_i-54]=chr(_i)
endfor

_dt=dtoc(DATE())
_tm=TIME()
_jb=val(right(_dt,2)+LEFT(_dt,2)+SUBSTR(_dt,4,2)+LEFT(_tm,2)+SUBSTR(_tm,4,2)+right(_tm,2))
_jobnum=''
_step = 1
do while _jb > 35
  _step = _step * 36
  _jt = mod(_jb,36)
  _jb = _jb / 36
  _jobnum=_alph[int(_jt+1)]+_jobnum
enddo
_jobnum=_alph[int(_jb+1)]+_jobnum
return _jobnum
**

**
function fxdate
**
parameter idate, odate
private idate, i, dd, mm, yyyy
m.odate=''
m.dd=''
m.mm=''
m.yyyy=''
m.idate = alltrim(m.idate)
j=len(m.idate)
for i = 1 to j
  if substr(m.idate,i,1) $ ',.-'
  else
     m.dd = m.dd + substr(m.idate,i,1)
  endif
next i
m.idate = m.dd
m.dd = ''

j=len(m.idate)
for i = 1 to j
  if substr(m.idate,i,1) = ' '
     exit
  else
     m.dd = m.dd + substr(m.idate,i,1)
  endif
next i
if len(m.dd) = 1
   m.dd = '0'+m.dd
endif

m.idate = alltrim(substr(m.idate,i+1))
j=len(m.idate)
for i = 1 to j
  if substr(m.idate,i,1) = ' '
     exit
  else
     m.mm = m.mm + substr(m.idate,i,1)
  endif
next i
m.mm = proper(m.mm)

m.idate = substr(m.idate,i+1)
m.yyyy = m.idate
if len(m.yyyy) = 2
   m.yyyy = '20'+m.yyyy
endif

m.odate = dd+' '+mm+' '+yyyy
return m.odate

**
function gtband
**
parameter _infreq
private _infreq, _outband
   _outband = ' '
   do case
      case _infreq < 1.8
          _outband =  ' '
      case _infreq < 3.5
           _outband =  '160'
      case _infreq < 4.5
           _outband =  '80'
      case _infreq < 5.5
           _outband =  '60'
      case _infreq < 7.5
           _outband =  '40'
      case _infreq < 11
           _outband =  '30'
      case _infreq < 15
           _outband =  '20'
      case _infreq < 18.2
           _outband =  '17'
      case _infreq < 22
           _outband =  '15'
      case _infreq < 25
           _outband =  '12'
      case _infreq < 30
           _outband =  '10'
      case _infreq < 55
           _outband =  '6'
      case _infreq < 149
           _outband =  '2'
      case _infreq < 230
           _outband =  '1.3'
      otherwise

   endcase
return _outband


**
procedure setband
**
   replace band with gtband(qso_freq)
return



**
function dtlong
**
parameter indt
private indt, indtc
indtc = dtoc(indt,1)   && 20090101
return substr(indtc,1,4)+'-'+substr(indtc,5,2)+'-'+substr(indtc,7,2)




**
**
**

